/**************************************************************************
 
 	asteroid.h 
 
  	Project: RockBlast an asteroid game. 
 
	Copyright (c) Febuary 2001 Garett Spencley
 
   	This program is free software; you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
   	the Free Software Foundation; either version 2, or (at your option)
   	any later version.

   	This program is distributed in the hope that it will be useful,
   	but WITHOUT ANY WARRANTY; without even the implied warranty of
   	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   	GNU General Public License for more details.

   	You should have received a copy of the GNU General Public License
   	along with this program; if not, write to the Free Software Foundation,
   	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

****************************************************************************/

#ifndef __RB_ASTEROID__
#define __RB_ASTEROID__

#include <time.h>

#include "video.h"
#include "rockblast.h"
#include "ball.h"

#define SPECIAL_TIME_LIMIT 5

enum { 
	NORMAL, BLOCKER, ONE_UP, 
	TEMP_BLOCKER, BONUS1, BONUS2, 
	KILLER, NUM_TYPES
};

typedef struct {
	bool alive;
	time_t ts;
	unsigned int type;
	int hits;
	object obj;
} asteroid_t;

bool create_asteroids(asteroid_t *, int);
inline void draw_asteroids(asteroid_t *, int);
inline void erase_asteroids(asteroid_t *, int);
void free_asteroids(asteroid_t *, int);
bool init_asteroids(void);
inline bool create_special(void);
void special_asteroid(asteroid_t *, int);
void ball_meets_asteroid(ball_t *, asteroid_t *);
void asteroid_score(unsigned int);

#endif
