/**************************************************************************
 
 	audio.h
 
  	Project: RockBlast an asteroid game. 
 
	Copyright (c) Febuary 2001 Garett Spencley
 
   	This program is free software; you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
   	the Free Software Foundation; either version 2, or (at your option)
   	any later version.

   	This program is distributed in the hope that it will be useful,
   	but WITHOUT ANY WARRANTY; without even the implied warranty of
   	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   	GNU General Public License for more details.

   	You should have received a copy of the GNU General Public License
   	along with this program; if not, write to the Free Software Foundation,
   	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

****************************************************************************/

#ifndef __AUDIO_H__
#define __AUDIO_H__

//#define _NO_SOUND

#include "rockblast.h"

enum {
	DIE, BLOWUP, ONEUP, BUMP, BONUS, NUM_SOUNDS
};

#ifndef _NO_SOUND

#include "SDL_mixer.h"

extern Mix_Chunk *sounds[NUM_SOUNDS];
extern Mix_Music *music;

bool init_audio(void);
bool load_audio(void);
void loop_music(void);
void play_sample(unsigned int);
void free_audio(void);

#else

/* No audio */

#ifdef __GNUC__

/* optimize for gcc */

static inline bool init_audio() { return true; }
static inline bool load_audio(void) { return true; }
static inline void loop_music(void) {}
static inline void play_sample(unsigned int x) {}
static inline void free_audio(void) {}

#else 

bool init_audio(void);
bool load_audio(void);
void loop_music(void);
void play_sample(unsigned int);
void free_audio(void);

#endif /* __GNUC__ */
#endif /* _NO_SOUND */

#endif
