/**************************************************************************
 
 	video.h
 
  	Project: RockBlast an asteroid game. 
 
	Copyright (c) Febuary 2001 Garett Spencley
 
   	This program is free software; you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
   	the Free Software Foundation; either version 2, or (at your option)
   	any later version.

   	This program is distributed in the hope that it will be useful,
   	but WITHOUT ANY WARRANTY; without even the implied warranty of
   	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   	GNU General Public License for more details.

   	You should have received a copy of the GNU General Public License
   	along with this program; if not, write to the Free Software Foundation,
   	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

****************************************************************************/

#ifndef __RB_VIDEO__
#define __RB_VIDEO__

#include "rockblast.h"

#define MODE_X 800
#define MODE_Y 600
#define BPP      0

#define VIDEO_FLAGS SDL_ANYFORMAT | SDL_RESIZABLE | SDL_DOUBLEBUF

#define MAX_UPDATES 350

#define FPS 32

typedef struct {
	int x, y;
	SDL_Surface *image;
} object;

typedef struct {
	SDL_Surface *src;
	SDL_Rect *srcrect;
	SDL_Rect *dstrect;
} blit;

bool init_video();
void init_blits();
void free_video();
void draw_object(object *);
void erase_object(object *);
void paint_background(void);
bool set_background(SDL_Surface *);
void wait_frame(int);
void update_screen();

SDL_Surface *video_resize(int w, int h);
extern SDL_Surface *screen;

#endif
